"use strict";

const pDefer = require("p-defer");

module.exports = function createPauser() {
	let isPaused = false;
	let promise, resolve;

	return {
		await: function (passthroughValue) {
			if (isPaused) {
				return promise.then(() => {
					return passthroughValue;
				});
			} else {
				return passthroughValue;
			}
		},
		pause: function () {
			isPaused = true;

			let defer = pDefer();
			promise = defer.promise;
			resolve = defer.resolve;
		},
		unpause: function () {
			if (isPaused) {
				isPaused = false;
				resolve();
			}
		}
	};
};
